# frozen_string_literal: true

module Hermes
  # Applicant serializer
  class UserRightSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}#{object.user.updated_at}" }, expires_in: 1.day
    attributes %i[
      right
      type
      title
      group_id
      entity_id
      lessor_id
      user_id
      user_email
      user_first_name
      user_last_name
      user_phone_number
      user_auth_roles
    ]


    def responsible
      nil
    end

    def user_email
      object.user&.email
    end

    def user_first_name
      object.user&.first_name
    end

    def user_last_name
      object.user&.last_name
    end

    def user_phone_number
      object.user&.phone_number
    end

    def user_auth_roles
      object.user&.auth_roles
    end

  end
end
