module Hermes
  
  module Kyc
    # Handlers for transition from old to enw
    class KycImpon2 < KycImpon1
      def get_tax_field
        hash = {"referenceIncome" => @required_document.applicant.amount_year_minus_two}
        Curl::PostField.content("taxHousehold",  hash.to_json)
      end

      def custom_check(parsed_body)
        return unless parsed_body["taxNoticeDetails"] && parsed_body["taxNoticeDetails"]["issuanceDate"]
        if (parsed_body["taxNoticeDetails"]["issuanceDate"][0..3] != (Time.current.year - 2).to_s)
          @analysed_response[:status] = 'Pièce invalide'
          @analysed_response[:validation_errors].push({message: "La piece fournie ne corresponds pas à la bonne année.", status: "KO"})
        else
          @analysed_response[:validity_limit] = Time.current + 1.years
        end
        
      end
    end
  end

end