module Hermes
  module Tools
    module Typology
      class Typology
        def initialize(from)
          case from.class.name
          when "String"
            if from.is_typology
              @number = from[1,-1]
            end
          when /Integer|Number/
            @number = from
          else
            raise "Typology class need a String or an Integer to initialize"
          end
        end

        def number
          @number
        end

        def to_string
          "T#{@number}"
        end

        alias_method :to_s, :to_string
      end

      class ::String
        def is_typology?
          (self =~ /^T[1-9][0-9]*?$/i) >= 0 rescue false
        end
        def to_typology
          Typology.new(self)
        end
      end

      class ::Symbol
        def is_typology?
          self.to_s.is_typology?
        end
        def to_typology
          self.to_s.to_typology
        end
      end

      class ::Integer
        def to_typology
          Typology.new(self)
        end
      end
    end
  end
end

include Hermes::Tools::Typology